/************************************************************************************/
/*  Program name CAPFAIMP_ASSET_HISTORY.sql                                        	*/
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 17 JAN, 2006   NIP Karen         First created                               	*/
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

ALTER TRIGGER FA_ASSET_HISTORY_BRU DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAIMP_ASSET_HISTORY';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FA_ASSET_HISTORY;
	

BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN		
			INSERT INTO FA_ASSET_HISTORY
			VALUES
			(
			CAPBRIMP_MAPPING.GetAssetIDMapping(C1.ASSET_ID),
			C1.CATEGORY_ID,
			C1.ASSET_TYPE,
			C1.UNITS,
			C1.DATE_EFFECTIVE,
			C1.DATE_INEFFECTIVE,
			CAPBRIMP_MAPPING.GetTXNHeaderIDMapping(C1.TRANSACTION_HEADER_ID_IN),
			CAPBRIMP_MAPPING.GetTXNHeaderIDMapping(C1.TRANSACTION_HEADER_ID_OUT),
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),
			C1.LAST_UPDATE_LOGIN
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/

ALTER TRIGGER FA_ASSET_HISTORY_BRU ENABLE;